org.h2.value

## Class ValueTimestampTimeZone

- java.lang.Object
- - org.h2.value.VersionedValue<Value>
  - - org.h2.value.Value
    - - org.h2.value.ValueTimestampTimeZone

All Implemented Interfaces:
  HasSQL, Typed

    public final class ValueTimestampTimeZone
    extends Value

Implementation of the TIMESTAMP WITH TIME ZONE data type.

### Field Summary

Fields
`static int` `DEFAULT_PRECISION` The default precision and display size of the textual representation of a timestamp.
`static int` `MAXIMUM_PRECISION` The maximum precision and display size of the textual representation of a timestamp.

### Fields inherited from class org.h2.value.Value

`ARRAY, BIGINT, BINARY, BLOB, BOOLEAN, CHAR, CLOB, DATE, DECFLOAT, DOUBLE, EMPTY_VALUES, ENUM, GEOMETRY, INTEGER, INTERVAL_DAY, INTERVAL_DAY_TO_HOUR, INTERVAL_DAY_TO_MINUTE, INTERVAL_DAY_TO_SECOND, INTERVAL_HOUR, INTERVAL_HOUR_TO_MINUTE, INTERVAL_HOUR_TO_SECOND, INTERVAL_MINUTE, INTERVAL_MINUTE_TO_SECOND, INTERVAL_MONTH, INTERVAL_SECOND, INTERVAL_YEAR, INTERVAL_YEAR_TO_MONTH, JAVA_OBJECT, JSON, MIN_LONG_DECIMAL, NULL, NUMERIC, REAL, ROW, SMALLINT, TIME, TIME_TZ, TIMESTAMP, TIMESTAMP_TZ, TINYINT, TYPE_COUNT, UNKNOWN, UUID, VARBINARY, VARCHAR, VARCHAR_IGNORECASE`

### Fields inherited from interface org.h2.util.HasSQL

`ADD_PLAN_INFORMATION, DEFAULT_SQL_FLAGS, NO_CASTS, QUOTE_ONLY_WHEN_REQUIRED, REPLACE_LOBS_FOR_TRACE, TRACE_SQL_FLAGS`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`int` `compareTypeSafe(Value o, CompareMode mode, CastDataProvider provider)` Compare this value against another value given that the values are of the same data type.
`boolean` `equals(java.lang.Object other)` Check if the two values have the same hash code.
`static ValueTimestampTimeZone` `fromDateValueAndNanos(long dateValue, long timeNanos, int timeZoneOffsetSeconds)` Get or create a date value for the given date.
`long` `getDateValue()` A bit field with bits for the year, month, and day (see DateTimeUtils for encoding).
`java.lang.String` `getISOString()` Returns value as string in ISO format.
`int` `getMemory()` Get the memory used by this object.
`java.lang.StringBuilder` `getSQL(java.lang.StringBuilder builder, int sqlFlags)` Appends the SQL statement of this object to the specified builder.
`java.lang.String` `getString()` Get the value as a string.
`long` `getTimeNanos()` The nanoseconds since midnight.
`int` `getTimeZoneOffsetSeconds()` The time zone offset in seconds.
`TypeInfo` `getType()` Returns the data type.
`int` `getValueType()` Get the value type.
`int` `hashCode()`
`static ValueTimestampTimeZone` `parse(java.lang.String s, CastDataProvider provider)` Parse a string to a ValueTimestamp.

### Methods inherited from class org.h2.value.Value

`add, castTo, charLength, clearCache, compareTo, compareWithNull, containsNull, convertForAssignTo, convertTo, convertTo, convertTo, convertTo, convertTo, convertToAnyArray, convertToAnyRow, convertToBigint, convertToBoolean, convertToChar, convertToDate, convertToDouble, convertToEnum, convertToGeometry, convertToInt, convertToInt, convertToJavaObject, convertToReal, convertToSmallint, convertToTinyint, convertToUuid, divide, getBigDecimal, getBoolean, getByte, getBytes, getBytesNoCopy, getDouble, getFloat, getHigherOrder, getInputStream, getInputStream, getInt, getLong, getReader, getReader, getShort, getSignum, getTypeName, getUnsupportedExceptionForOperation, isFalse, isTrue, modulus, multiply, negate, octetLength, subtract, toString`

### Methods inherited from class org.h2.value.VersionedValue

`getCommittedValue, getCurrentValue, getOperationId, isCommitted`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.h2.util.HasSQL

`getSQL, getTraceSQL`

### Field Detail

#### DEFAULT_PRECISION

    public static final int DEFAULT_PRECISION

The default precision and display size of the textual representation of a timestamp. Example: 2001-01-01 23:59:59.123456+10:00

See Also:
  Constant Field Values

#### MAXIMUM_PRECISION

    public static final int MAXIMUM_PRECISION

The maximum precision and display size of the textual representation of a timestamp. Example: 2001-01-01 23:59:59.123456789+10:00

See Also:
  Constant Field Values

### Method Detail

#### fromDateValueAndNanos

    public static ValueTimestampTimeZone fromDateValueAndNanos(long dateValue,
                                                               long timeNanos,
                                                               int timeZoneOffsetSeconds)

Get or create a date value for the given date.

Parameters:
  `dateValue` - the date value, a bit field with bits for the year, month, and day
  `timeNanos` - the nanoseconds since midnight
  `timeZoneOffsetSeconds` - the timezone offset in seconds
Returns:
  the value

#### parse

    public static ValueTimestampTimeZone parse(java.lang.String s,
                                               CastDataProvider provider)

Parse a string to a ValueTimestamp. This method supports the format +/-year-month-day hour:minute:seconds.fractional and an optional timezone part.

Parameters:
  `s` - the string to parse
  `provider` - the cast information provider, may be `null` for literals with time zone
Returns:
  the date

#### getDateValue

    public long getDateValue()

A bit field with bits for the year, month, and day (see DateTimeUtils for encoding).

Returns:
  the data value

#### getTimeNanos

    public long getTimeNanos()

The nanoseconds since midnight.

Returns:
  the nanoseconds

#### getTimeZoneOffsetSeconds

    public int getTimeZoneOffsetSeconds()

The time zone offset in seconds.

Returns:
  the offset

#### getType

    public TypeInfo getType()

Description copied from interface: `Typed`
Returns the data type.

Specified by:
  `getType` in interface `Typed`
Specified by:
  `getType` in class `Value`
Returns:
  the data type

#### getValueType

    public int getValueType()

Description copied from class: `Value`
Get the value type.

Specified by:
  `getValueType` in class `Value`
Returns:
  the value type

#### getMemory

    public int getMemory()

Description copied from class: `Value`
Get the memory used by this object.

Overrides:
  `getMemory` in class `Value`
Returns:
  the memory used in bytes

#### getString

    public java.lang.String getString()

Description copied from class: `Value`
Get the value as a string.

Specified by:
  `getString` in class `Value`
Returns:
  the string

#### getISOString

    public java.lang.String getISOString()

Returns value as string in ISO format.

Returns:
  value as string in ISO format

#### getSQL

    public java.lang.StringBuilder getSQL(java.lang.StringBuilder builder,
                                          int sqlFlags)

Description copied from interface: `HasSQL`
Appends the SQL statement of this object to the specified builder.

Parameters:
  `builder` - string builder
  `sqlFlags` - formatting flags
Returns:
  the specified string builder

#### compareTypeSafe

    public int compareTypeSafe(Value o,
                               CompareMode mode,
                               CastDataProvider provider)

Description copied from class: `Value`
Compare this value against another value given that the values are of the same data type.

Specified by:
  `compareTypeSafe` in class `Value`
Parameters:
  `o` - the other value
  `mode` - the compare mode
  `provider` - the cast information provider
Returns:
  0 if both values are equal, -1 if the other value is smaller, and 1 otherwise

#### equals

    public boolean equals(java.lang.Object other)

Description copied from class: `Value`
Check if the two values have the same hash code. No data conversion is made; this method returns false if the other object is not of the same class. For some values, compareTo may return 0 even if equals return false. Example: ValueDecimal 0.0 and 0.00.

Specified by:
  `equals` in class `Value`
Parameters:
  `other` - the other value
Returns:
  true if they are equal

#### hashCode

    public int hashCode()

Specified by:
  `hashCode` in class `Value`